local original_check_medic_heal = CopDamage.check_medic_heal
local last_attack_data = nil
local last_attack_type = nil

Hooks:PreHook(CopDamage, "damage_bullet", "damage_bullet_tactical_retreat", function(self, attack_data)
    last_attack_data = attack_data
    last_attack_type = "bullet"
end)
Hooks:PreHook(CopDamage, "damage_fire", "damage_fire_tactical_retreat", function(self, attack_data)
    last_attack_data = attack_data
    last_attack_type = "fire"
end)
Hooks:PreHook(CopDamage, "damage_explosion", "damage_explosion_tactical_retreat", function(self, attack_data)
    last_attack_data = attack_data
    last_attack_type = "explosion"
end)
Hooks:PreHook(CopDamage, "damage_dot", "damage_dot_tactical_retreat", function(self, attack_data)
    last_attack_data = attack_data
    last_attack_type = attack_data.variant or "posion"
end)
Hooks:PreHook(CopDamage, "damage_simple", "damage_simple_tactical_retreat", function(self, attack_data)
    last_attack_data = attack_data
    last_attack_type = attack_data.variant
end)
Hooks:PreHook(CopDamage, "damage_melee", "damage_melee_tactical_retreat", function(self, attack_data)
    last_attack_data = attack_data
    last_attack_type = "melee"
end)
Hooks:PreHook(CopDamage, "damage_tase", "damage_tase_tactical_retreat", function(self, attack_data)
    last_attack_data = attack_data
    last_attack_type = "tase"
end)

function CopDamage:check_medic_heal()
    local was_healed = original_check_medic_heal(self)
    --If medic saved them, they keep fighting
    if was_healed then
        return true
    end
    --If medic did not save them, they go home

    --Triggering whatever mission elements are listening
    if self._unit:unit_data().mission_element then
		self._unit:unit_data().mission_element:event("death", self._unit)

		if not self._unit:unit_data().alerted_event_called then
			self._unit:unit_data().alerted_event_called = true

			self._unit:unit_data().mission_element:event("alerted", self._unit)
		end
	end

    --Triggering almost all the "on kill" things
    if last_attack_type and last_attack_data then
        managers.mutators:notify(Message.OnCopDamageDeath, self._unit, last_attack_data)
        managers.player:send_message(Message.OnEnemyShot, nil, self._unit, last_attack_data)
        local head = self._head_body_name and last_attack_data.col_ray.body and last_attack_data.col_ray.body:name() == self._ids_head_body_name
        self:chk_killshot(last_attack_data.attacker_unit, last_attack_type, head, last_attack_data.weapon_unit and last_attack_data.weapon_unit:base():get_name_id())
    end
    self:_on_death()
    
    --set logic to "is being traded"
    self._unit:brain():set_logic('trade', {
		skip_hint = true
	})
    -- actually performing trade
    local data = self._unit:brain()._logic_data
    data.internal_data.trade_enabled = true
    --false at the end disables freeing any criminals on this fake trade
    self._unit:brain():on_trade(data, self._unit:position(), self._unit:rotation(), false)

    --Set HP to max
    local cop_dmg = self._unit:character_damage()
    cop_dmg._health = cop_dmg._HEALTH_INIT
    cop_dmg._health_ratio = 1
    cop_dmg:_update_debug_ws()
    
    --No collissions
    self:set_mover_collision_state(false)
    
    --Dropping ammo and shield
    self:drop_pickup()
    self._unit:inventory():drop_shield()
    
    --Invulnerability
    self._unit:character_damage():set_invulnerable(true)
    self._unit:network():send("set_unit_invulnerable", true, self._unit:character_damage()._immortal)

    --If killed unit is a medic, removing them from list of medics
    if self._unit:character_damage()._unregister_healing then
        self._unit:character_damage():_unregister_healing()
    end

    --true tells the game that this unit was saved by a medic and should not die
    return true
end
